<?

// Gallery's configuration form handler
sapp_include_once('common.php'); 

/**
* Checks the validity of the current form.
*
* @return integer
*/
function form_handler()
{
	
	$valid_required = true;
	$valid_optional = true;

	/*******************************
	 *
	 *	Required parameters
	 *
	 *******************************/

	$valid_required &= check_and_set_required('admin_login', 'check_sys_login');
	$valid_required &= check_and_set_required('admin_email', 'check_email');
	
	//check admin password
	$gal_admin_passwd = sapp_get_submit_value('admin_passwd');
	$gal_admin_confirm = sapp_get_submit_value('admin_confirm');
	if ('' == $gal_admin_passwd) {
		if (!sapp_get_param('admin_passwd')) {
			sapp_set_wrong('admin_passwd', msg('password__empty'));
			$valid_required = false;
		} else {
			$gal_admin_passwd = sapp_get_param('admin_passwd');
		}
	} elseif ($gal_admin_passwd != $gal_admin_confirm) {
		sapp_set_wrong('admin_passwd', msg('password__not_match'));
		sapp_set_wrong('admin_confirm', msg('password__not_match'));
		$valid_required = false;
	} elseif (!check_sys_passwd(sapp_get_param('admin_login'), $gal_admin_passwd)) {
		sapp_set_wrong('admin_passwd', msg('invalid_value'));
		$valid_required = false;
	} else {
    	$valid_required &= check_and_set_required('admin_passwd');
	}

	if (!$valid_required)
		sapp_set_warning('Not all required parameters are correctly specifyed');
			
	if (sapp_get_param('admin_passwd') != sapp_get_param('admin_confirm'))
		sapp_set_warning('Passwords are not equal');

	$salt = '';
	for ($i = 0; $i < 4; $i++) {
		$char = mt_rand(48, 109);
		$char += ($char > 90) ? 13 : ($char > 57) ? 7 : 0;
		$salt .= chr($char);
	}
	$admin_hash=$salt . md5($salt . $gal_admin_passwd);
	sapp_set_param("admin_hash", $admin_hash);



	$valid_optional &= check_and_set_optional('gallery_name');
	$valid_optional &= check_and_set_optional('admin_fullname');
#        $valid_optional &= check_and_set_optional('locale');


	if (!$valid_optional)
		sapp_set_warning('Optional parameters are wrong');
		
	if (!$valid_optional || !$valid_required)
		return 1;
		
	return 2;
}
?>
